/***************************************************************************
                          utils.h  -  description
                             -------------------

    This file is a part of kpl - a program for graphical presentation of
    data sets and functions.

    begin                : Sun Apr 25 1999
    copyright            : (C) 2000 by Werner Stille
    email                : stille@uni-freiburg.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class KplDoc;
class QMultiLineEdit;
class QFile;

bool getVal(QWidget *parent, QLineEdit *edit, double *val,
            const char *errmsg);
void getFile(QLineEdit *e, KplDoc *m);
void getFunc(QWidget *parent, QLineEdit *name, QLineEdit *func);
void getPar(QWidget *parent, double *p, KplDoc *m);
void savePar(QWidget *parent, double *p, KplDoc *m);
void showSource(QMultiLineEdit *ml, QFile *f, const char *func);
bool getFun(QString path, QString name, void **hmod,
            double (**fkt)(double, double *));
int minMaxFl(double *xmin, double *xmax, double *x, int n);
void expo(double a, int *ie, double *f);
void expoFl(int *ie, double *f, double *x, int n);
void expoFn(double (*fkt)(double, double *), int *ie, double *f,
            double xmin, double xmax, double dx, double *p);
bool autoSc(double *xmi, double *xma, double *tic, int *mtic, int *ndig,
            double xmin, double xmax, double fx, double c);
bool autoFn(double *ymi, double *yma, double *tic, int * mtic, int *ndig,
            double (*fkt)(double, double *), double xmin, double xmax,
            double dx, double *p, double fn, double c);
bool autoFl(double *xmi, double *xma, double *tic, int *mtic, int *ndig,
            int *ie, double *fn, double *x, int n, int norm, double c);
int int9(double a);

#ifdef __cplusplus
extern "C" {
#endif

int minv(double A[], double X[], int n, double B[], int IPS[]);
double igamc(double a, double x);
double igam(double a, double x);
double lgam(double x);

#ifdef __cplusplus
}
#endif
